/// The units system that the unit is defined in.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    Default
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct UnitSystem(pub String);
impl std::fmt::Display for UnitSystem {
    fn fmt(&self, fmt: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        std::fmt::Display::fmt(&self.0, fmt)
    }
}
impl conjure_object::Plain for UnitSystem {
    fn fmt(&self, fmt: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        conjure_object::Plain::fmt(&self.0, fmt)
    }
}
impl conjure_object::FromPlain for UnitSystem {
    type Err = <String as conjure_object::FromPlain>::Err;
    #[inline]
    fn from_plain(s: &str) -> Result<UnitSystem, Self::Err> {
        conjure_object::FromPlain::from_plain(s).map(UnitSystem)
    }
}
impl std::convert::From<String> for UnitSystem {
    #[inline]
    fn from(v: String) -> Self {
        UnitSystem(std::convert::From::from(v))
    }
}
impl std::ops::Deref for UnitSystem {
    type Target = String;
    #[inline]
    fn deref(&self) -> &String {
        &self.0
    }
}
impl std::ops::DerefMut for UnitSystem {
    #[inline]
    fn deref_mut(&mut self) -> &mut String {
        &mut self.0
    }
}
impl std::convert::AsRef<String> for UnitSystem {
    #[inline]
    fn as_ref(&self) -> &String {
        &self.0
    }
}
